=== test/integration/CMakeLists.txt ===
set_property(DIRECTORY APPEND
        PROPERTY LABELS integration_tests
)
#Spglib_add_gtest(TARGET Spglib_tests SOURCES
#)
