=== debian/changelog ===
spglib (2.6.0-3build1) resolute; urgency=medium

  * No-change rebuild with Python 3.14 as supported version

 -- Graham Inggs <ginggs@ubuntu.com>  Mon, 20 Oct 2025 15:05:43 +0000

spglib (2.6.0-3) unstable; urgency=medium

  * Drop Multi-Arch: same from libspglib-f08-dev (Closes: #1103017)

 -- Andrius Merkys <merkys@debian.org>  Tue, 15 Apr 2025 01:40:09 -0400

spglib (2.6.0-2) unstable; urgency=medium

  * Team upload.
  * d/p/pyproject.toml.patch: Remove license hunk. (Closes: #1102784)

 -- Sergio Durigan Junior <sergiodj@debian.org>  Sat, 12 Apr 2025 16:46:09 -0400

spglib (2.6.0-1) unstable; urgency=medium

  * New upstream version 2.6.0
  * Update debian/copyright.
  * Drop ruby-getspg binary package.
    See https://github.com/spglib/spglib/issues/564 for rationale.

 -- Andrius Merkys <merkys@debian.org>  Fri, 14 Mar 2025 06:34:50 -0400
