=== debian/control ===
Source: spglib
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders:
 Andrius Merkys <merkys@debian.org>,
Section: science
Priority: optional
Build-Depends:
 cmake,
 debhelper-compat (= 13),
 dh-python,
 dh-sequence-numpy3,
 gfortran,
 libgtest-dev,
 moreutils,
 pybuild-plugin-pyproject,
 python3-all-dev,
 python3-build,
 python3-numpy,
 python3-pathspec,
 python3-pyproject-metadata,
 python3-pytest <!nocheck>,
 python3-scikit-build-core,
 python3-setuptools,
 python3-setuptools-scm,
 python3-yaml (>= 5),
Standards-Version: 4.2.1
Vcs-Browser: https://salsa.debian.org/science-team/spglib
Vcs-Git: https://salsa.debian.org/science-team/spglib.git
Homepage: https://spglib.github.io/spglib/
Rules-Requires-Root: no
Testsuite: autopkgtest-pkg-pybuild

Package: libspglib-f08-2
Architecture: any
Multi-Arch: same
Section: libs
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: C library for crystal symmetry determination (Fortran interface)
 Spglib is a C library for crystal symmetry determination. Symmetry
 operations, space groups and other data can be obtained using this
 symmetry finder.
 .
 Features include:
 .
  * Identify space-group type
  * Find symmetry operations
  * Find a primitive cell
  * Search irreducible k-points
  * Refine crystal structure
  * Wyckoff position assignment
 .
 This package contains Fortran interface.

Package: libspglib-f08-dev
Architecture: any
Section: libdevel
Depends:
 libspglib-f08-2 (= ${binary:Version}),
 ${misc:Depends},
Description: C library for crystal symmetry determination (Fortran development files)
 Spglib is a C library for crystal symmetry determination. Symmetry
 operations, space groups and other data can be obtained using this
 symmetry finder.
 .
 Features include:
 .
  * Identify space-group type
  * Find symmetry operations
  * Find a primitive cell
  * Search irreducible k-points
  * Refine crystal structure
  * Wyckoff position assignment
 .
 This package contains development files for Fortran interface.

Package: libsymspg-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends:
 libsymspg2 (= ${binary:Version}),
 ${misc:Depends},
Description: C library for crystal symmetry determination (development files)
 Spglib is a C library for crystal symmetry determination. Symmetry
 operations, space groups and other data can be obtained using this
 symmetry finder.
 .
 Features include:
 .
  * Identify space-group type
  * Find symmetry operations
  * Find a primitive cell
  * Search irreducible k-points
  * Refine crystal structure
  * Wyckoff position assignment
 .
 This package contains static library and header files.

Package: libsymspg2
Architecture: any
Multi-Arch: same
Section: libs
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: C library for crystal symmetry determination
 Spglib is a C library for crystal symmetry determination. Symmetry
 operations, space groups and other data can be obtained using this
 symmetry finder.
 .
 Features include:
 .
  * Identify space-group type
  * Find symmetry operations
  * Find a primitive cell
  * Search irreducible k-points
  * Refine crystal structure
  * Wyckoff position assignment

Package: python3-spglib
Architecture: any
Section: python
Depends:
 python3-numpy,
 ${misc:Depends},
 ${python3:Depends},
 ${shlibs:Depends},
XB-Python-Version: ${python3:Versions}
Provides:
 ${python3:Provides},
Description: C library for crystal symmetry determination - Python3 bindings
 Spglib is a C library for crystal symmetry determination. Symmetry
 operations, space groups and other data can be obtained using this
 symmetry finder.
 .
 Features include:
 .
  * Identify space-group type
  * Find symmetry operations
  * Find a primitive cell
  * Search irreducible k-points
  * Refine crystal structure
  * Wyckoff position assignment
 .
 This package contains the Python3 bindings.
