=== debian/watch ===
version=4
opts="filenamemangle=s/(?:.*?)?v?(\d[\d.]*)\.tar\.gz/spglib-$1.tar.gz/" \
   https://github.com/spglib/spglib/tags \
   (?:.*?/)?v?(\d[\d.]*)\.tar\.gz
