=== debian/changelog ===
spglib (2.7.0-1) unstable; urgency=medium

  * New upstream version 2.7.0

 -- Andrius Merkys <merkys@debian.org>  Fri, 09 Jan 2026 06:11:53 -0500
