=== debian/control ===
--- 
+++ 
@@ -12,6 +12,7 @@
  gfortran,
  libgtest-dev,
  moreutils,
+ pybind11-dev,
  pybuild-plugin-pyproject,
  python3-all-dev,
  python3-build,
