=== debian/rules ===
--- 
+++ 
@@ -1,6 +1,8 @@
 #!/usr/bin/make -f
 
 include /usr/share/dpkg/pkg-info.mk
+
+export DEB_CXXFLAGS_MAINT_APPEND = -fpermissive
 
 export PYBUILD_NAME = spglib
 export PYBUILD_SYSTEM = pyproject
